#define _CRTDBG_MAP_ALLOC

#include <stdlib.h>
#include <malloc.h>
#include <crtdbg.h>

#include <windows.h>
#include <d3d11_1.h>
#include "../Milkdrop2-XBMC-aaae8c2b905e2e61231083ac897838665f7fc0d0\Development\Src\vis_milk2\vis_milk2/plugin.h"
#include <math.h>
#include "IMaitoPisaraMach.h"

#define BlendTime 1.0f

HWND gHWND = NULL;

ID3D11Device*           pD3DDevice = nullptr;
ID3D11DeviceContext*    pImmediateContext = nullptr;
IDXGISwapChain*         pSwapChain = nullptr;
ID3D11RenderTargetView* pRenderTargetView = nullptr;
ID3D11DepthStencilView* pDepthStencilView = nullptr;
D3D_FEATURE_LEVEL       featureLevel = D3D_FEATURE_LEVEL_11_0;

bool buzzClosed;
int nDefaultWidth = 640;
int nDefaultHeight = 480;
bool mdWindowed = TRUE;
TCHAR MaitoPisaraWndClassName[MAX_PATH];
TCHAR MaitoPisaraWndName[MAX_PATH];

CPlugin g_plugin;
IMaitoPisaraMach* MaitoPisaraMach;

void BuzzClosed(bool state)
{
	buzzClosed = state;
}


int currentDisplayOutput = 0;
std::vector<IDXGIOutput*> outputArray; // contains outputs per adapter
void EnumOutputsOnAdapter(IDXGIAdapter* adapter)
{
	IDXGIOutput* output = NULL;
	for (int i = 0; DXGI_ERROR_NOT_FOUND != adapter->EnumOutputs(i, &output); ++i)
	{
		// get the description
		DXGI_OUTPUT_DESC outputDesc;
		HRESULT hr = output->GetDesc(&outputDesc);

		outputArray.push_back(output);
	}

}

HRESULT CreateDevice(int iWidth, int iHeight, bool bWindowed)
{
	HRESULT hr = S_OK;

	UINT createDeviceFlags = 0;
#ifdef _DEBUG
	createDeviceFlags |= D3D11_CREATE_DEVICE_DEBUG;
#endif
	D3D_FEATURE_LEVEL featureLevels[] =
	{
		D3D_FEATURE_LEVEL_11_1,
		D3D_FEATURE_LEVEL_11_0,
		D3D_FEATURE_LEVEL_10_1,
		D3D_FEATURE_LEVEL_10_0,
		D3D_FEATURE_LEVEL_9_3,
		D3D_FEATURE_LEVEL_9_2,
		D3D_FEATURE_LEVEL_9_1,
	};

	hr = D3D11CreateDevice(nullptr, D3D_DRIVER_TYPE_HARDWARE, nullptr, createDeviceFlags, featureLevels, ARRAYSIZE(featureLevels),
		D3D11_SDK_VERSION, &pD3DDevice, &featureLevel, &pImmediateContext);

	if (hr == E_INVALIDARG)
	{
		// DirectX 11.0 platforms will not recognize D3D_FEATURE_LEVEL_11_1 so we need to retry without it
		hr = D3D11CreateDevice(nullptr, D3D_DRIVER_TYPE_HARDWARE, nullptr, createDeviceFlags, &featureLevels[1], ARRAYSIZE(featureLevels) - 1,
			D3D11_SDK_VERSION, &pD3DDevice, &featureLevel, &pImmediateContext);
	}

	if (FAILED(hr))
		return hr;

	// Obtain DXGI factory from device (since we used nullptr for pAdapter above)
	IDXGIFactory1* dxgiFactory = nullptr;
	{
		IDXGIDevice* dxgiDevice = nullptr;
		hr = pD3DDevice->QueryInterface(__uuidof(IDXGIDevice), reinterpret_cast<void**>(&dxgiDevice));
		if (SUCCEEDED(hr))
		{
			IDXGIAdapter* adapter = nullptr;
			hr = dxgiDevice->GetAdapter(&adapter);
			if (SUCCEEDED(hr))
			{
				EnumOutputsOnAdapter(adapter);
				hr = adapter->GetParent(__uuidof(IDXGIFactory1), reinterpret_cast<void**>(&dxgiFactory));
				adapter->Release();
			}
			dxgiDevice->Release();
		}
	}

	if (FAILED(hr))
		return hr;

	// Create swap chain
	IDXGIFactory2* dxgiFactory2 = nullptr;
	hr = dxgiFactory->QueryInterface(__uuidof(IDXGIFactory2), reinterpret_cast<void**>(&dxgiFactory2));
	if (dxgiFactory2)
	{
		// DirectX 11.1 or later
		DXGI_SWAP_CHAIN_DESC1 sd;
		ZeroMemory(&sd, sizeof(sd));
		sd.Width = iWidth;
		sd.Height = iHeight;
		sd.Format = DXGI_FORMAT_R8G8B8A8_UNORM;
		sd.SampleDesc.Count = 1;
		sd.SampleDesc.Quality = 0;
		sd.BufferUsage = DXGI_USAGE_RENDER_TARGET_OUTPUT;
		sd.BufferCount = 2;
		sd.SwapEffect = DXGI_SWAP_EFFECT_SEQUENTIAL;
		sd.Flags = DXGI_SWAP_CHAIN_FLAG_ALLOW_MODE_SWITCH;

		IDXGISwapChain1* pSwapChain1 = nullptr;
		hr = dxgiFactory2->CreateSwapChainForHwnd(pD3DDevice, gHWND, &sd, nullptr, nullptr, &pSwapChain1);
		if (SUCCEEDED(hr))
		{
			hr = pSwapChain1->QueryInterface(__uuidof(IDXGISwapChain), reinterpret_cast<void**>(&pSwapChain));
			pSwapChain1->Release();
		}

		dxgiFactory2->Release();
	}
	else
	{
		// DirectX 11.0 systems
		DXGI_SWAP_CHAIN_DESC sd;
		ZeroMemory(&sd, sizeof(sd));
		sd.BufferCount = 2;
		sd.BufferDesc.Width = iWidth;
		sd.BufferDesc.Height = iHeight;
		sd.BufferDesc.Format = DXGI_FORMAT_R8G8B8A8_UNORM;
		sd.BufferDesc.RefreshRate.Numerator = 60;
		sd.BufferDesc.RefreshRate.Denominator = 1;
		sd.BufferUsage = DXGI_USAGE_RENDER_TARGET_OUTPUT;
		sd.SwapEffect = DXGI_SWAP_EFFECT_SEQUENTIAL;
		sd.OutputWindow = gHWND;
		sd.SampleDesc.Count = 1;
		sd.SampleDesc.Quality = 0;
		sd.Windowed = TRUE;

		hr = dxgiFactory->CreateSwapChain(pD3DDevice, &sd, &pSwapChain);
	}

	dxgiFactory->MakeWindowAssociation(gHWND, DXGI_MWA_NO_ALT_ENTER);
	dxgiFactory->Release();

	if (FAILED(hr))
		return hr;

	// Create a render target view
	ID3D11Texture2D* pBackBuffer = nullptr;
	hr = pSwapChain->GetBuffer(0, __uuidof(ID3D11Texture2D), reinterpret_cast<void**>(&pBackBuffer));
	if (FAILED(hr))
		return hr;

	hr = pD3DDevice->CreateRenderTargetView(pBackBuffer, nullptr, &pRenderTargetView);
	pBackBuffer->Release();
	if (FAILED(hr))
		return hr;

	// Create depth stencil texture
	D3D11_TEXTURE2D_DESC descDepth;
	ZeroMemory(&descDepth, sizeof(descDepth));
	descDepth.Width = iWidth;
	descDepth.Height = iHeight;
	descDepth.MipLevels = 1;
	descDepth.ArraySize = 1;
	descDepth.Format = DXGI_FORMAT_D24_UNORM_S8_UINT;
	descDepth.SampleDesc.Count = 1;
	descDepth.SampleDesc.Quality = 0;
	descDepth.Usage = D3D11_USAGE_DEFAULT;
	descDepth.BindFlags = D3D11_BIND_DEPTH_STENCIL;
	descDepth.CPUAccessFlags = 0;
	descDepth.MiscFlags = 0;

	ID3D11Texture2D* pDepthStencil;
	hr = pD3DDevice->CreateTexture2D(&descDepth, nullptr, &pDepthStencil);
	if (FAILED(hr))
		return hr;

	// Create the depth stencil view
	D3D11_DEPTH_STENCIL_VIEW_DESC descDSV;
	ZeroMemory(&descDSV, sizeof(descDSV));
	descDSV.Format = descDepth.Format;
	descDSV.ViewDimension = D3D11_DSV_DIMENSION_TEXTURE2D;
	descDSV.Texture2D.MipSlice = 0;
	hr = pD3DDevice->CreateDepthStencilView(pDepthStencil, &descDSV, &pDepthStencilView);

	pDepthStencil->Release();

	if (FAILED(hr))
		return hr;

	pImmediateContext->OMSetRenderTargets(1, &pRenderTargetView, pDepthStencilView);

	// Setup the viewport
	CD3D11_VIEWPORT vp(0.0f, 0.0f, (float)iWidth, (float)iHeight);
	pImmediateContext->RSSetViewports(1, &vp);

	return hr;
}

LRESULT CALLBACK StaticWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_CLOSE:
	{
		HMENU hMenu;
		hMenu = GetMenu(hWnd);
		if (hMenu != NULL)
			DestroyMenu(hMenu);
		DestroyWindow(hWnd);
		UnregisterClass(MaitoPisaraWndClassName, NULL);
		return 0;
	}

	case WM_DESTROY:
	{
		
		if (!buzzClosed)
		MaitoPisaraMach->milkdropDeleted();
		
		PostQuitMessage(0);
	}
	break;
	}

	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

void RenderFrame()
{

	float color[4] = { 0.0f, 0.0f, 0.0f, 0.0f };
	pImmediateContext->ClearRenderTargetView(pRenderTargetView, color);

	float waves[576 * 2];

	if (!buzzClosed)
	{
		MaitoPisaraMach->getAudioBufferData(waves, 576);
	}

	g_plugin.PluginRender((unsigned char*)&waves[0], (unsigned char*)&waves[1]);
	

	pSwapChain->Present(1, 0);
}

void ToggleFullScreen()
{
	mdWindowed = !mdWindowed;
	bool GoingToFullScreen = !mdWindowed;
	if (GoingToFullScreen)
	{
		pSwapChain->SetFullscreenState(!mdWindowed, outputArray[currentDisplayOutput]);		
	}
	else
	{
		pSwapChain->SetFullscreenState(!mdWindowed, NULL);
	}	
}

void MainLoop()
{
	bool bGotMsg;
	MSG msg;
	msg.message = WM_NULL;
	PeekMessage(&msg, NULL, 0U, 0U, PM_NOREMOVE);

	while (WM_QUIT != msg.message)
	{
		// Use PeekMessage() so we can use idle time to render the scene. 
		bGotMsg = (PeekMessage(&msg, NULL, 0U, 0U, PM_REMOVE) != 0);

		if (bGotMsg)
		{			
			if (msg.message == WM_LBUTTONDBLCLK)
			{
				ToggleFullScreen();
			}

			if (msg.message == WM_CHAR && (gHWND == GetForegroundWindow()))
			{
				// (('n' == (char)wParam) && (GetKeyState(VK_ALT) < 0) && (GetKeyState(VK_SHIFT) >= 0) && (GetKeyState(VK_CONTROL) >= 0))
				if  ('n' == (char)msg.wParam) {				
					g_plugin.NextPreset(1.0f);
					}
				if ('p' == (char)msg.wParam) {
					g_plugin.PrevPreset(BlendTime);
				}
				if ('r' == (char)msg.wParam) {
					g_plugin.LoadRandomPreset(BlendTime);
				}
				if ('f' == (char)msg.wParam) {
					ToggleFullScreen();
				}
				if (27 == (char)msg.wParam) {
					if (!mdWindowed)
						ToggleFullScreen();
				}
				if ('1' == (char)msg.wParam) {
					currentDisplayOutput = 0;
					if (!mdWindowed)
					{
						ToggleFullScreen(); // switch to windowed...
						ToggleFullScreen(); // back to fullscreen
					}
				}
				if ('2' == (char)msg.wParam) {
					if (outputArray.size() >= 2)
					{
						currentDisplayOutput = 1;
						if (!mdWindowed)
						{
							ToggleFullScreen(); // switch to windowed...
							ToggleFullScreen(); // back to fullscreen
						}
					}
				}
				if ('3' == (char)msg.wParam) {
					if (outputArray.size() >= 3)
					{
						currentDisplayOutput = 2;
						if (!mdWindowed)
						{
							ToggleFullScreen(); // switch to windowed...
							ToggleFullScreen(); // back to fullscreen
						}
					}
				}
				if ('h' == (char)msg.wParam) {		
					// wchar_t *pluginsPath = g_plugin.GetPluginsDirPath();
					
				}
			}		

			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else
		{
			// Render a frame during idle time (no messages are waiting)
			RenderFrame();
		}
	}
}

void MaitoPisaraInitWindow(const TCHAR *classname, const TCHAR *WndName)
{
	strcpy(MaitoPisaraWndClassName, classname);
	strcpy(MaitoPisaraWndName, WndName);

}


int WINAPI MaitoPisaraWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdLine, int iCmdShow, IMaitoPisaraMach* callback)
{
	_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
	_CrtSetBreakAlloc(60);

	MaitoPisaraMach = callback;
	BuzzClosed(false);

	// Register the windows class
	WNDCLASS wndClass;
	wndClass.style = CS_DBLCLKS;
	wndClass.lpfnWndProc = StaticWndProc;
	wndClass.cbClsExtra = 0;
	wndClass.cbWndExtra = 0;
	wndClass.hInstance = hInstance;
	wndClass.hIcon = NULL;
	wndClass.hCursor = LoadCursor(NULL, IDC_ARROW);
	wndClass.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
	wndClass.lpszMenuName = NULL;
	wndClass.lpszClassName = MaitoPisaraWndClassName;

	if (!RegisterClass(&wndClass))
	{
		DWORD dwError = GetLastError();
		if (dwError != ERROR_CLASS_ALREADY_EXISTS)
			return -1;
	}

	// Find the window's initial size, but it might be changed later

	RECT rc;
	SetRect(&rc, 0, 0, nDefaultWidth, nDefaultHeight);
	AdjustWindowRect(&rc, WS_OVERLAPPEDWINDOW, false);

	// Create the render window
	HWND hWnd = CreateWindow(MaitoPisaraWndClassName, MaitoPisaraWndName, WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, CW_USEDEFAULT, (rc.right - rc.left), (rc.bottom - rc.top), 0,
		NULL, hInstance, 0);
	if (hWnd == NULL)
	{
		DWORD dwError = GetLastError();
		return -1;
	}
	gHWND = hWnd;

	ShowWindow(hWnd, SW_SHOW);

	if (S_OK != CreateDevice(nDefaultWidth, nDefaultHeight, mdWindowed))
		return -1;

	BOOL bSuccess;
	bSuccess = g_plugin.PluginPreInitialize(nullptr, nullptr);
	if (!bSuccess)
		return -1;
	bSuccess = g_plugin.PluginInitialize(pImmediateContext, 0, 0, nDefaultWidth, nDefaultHeight, nDefaultHeight / (float)nDefaultWidth);
	if (!bSuccess)
		return -1;

	MainLoop();

	g_plugin.PluginQuit();

	pImmediateContext->Flush();
	pImmediateContext->ClearState();

	pRenderTargetView->Release();
	pDepthStencilView->Release();
	pSwapChain->Release();
	pImmediateContext->Release();
	pD3DDevice->Release();

	outputArray.empty();

	return 0;
}

void BringMaitoPisaraWndOnTop()
{
	// Boo! This maks the windows somethimes always top most...
	// SetForegroundWindow(gHWND);
}

struct _DEBUG_STATE
{
	_DEBUG_STATE() {}
	~_DEBUG_STATE() { _CrtDumpMemoryLeaks(); }
};

#pragma init_seg(compiler)
_DEBUG_STATE ds;